controllers/SiteController.php
<?php

namespace app\controllers;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Control use behaviors
     * @return array[]
     */

    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['login', 'logout', 'signup'],
                'rules' => [
                    [
                        'allow' => true,
                        'actions' => ['login', 'signup'],
                        'roles' => ['?'],
                    ],
                    [
                        'allow' => true,
                        'actions' => ['logout'],
                        'roles' => ['@'],
                    ],
                ],
                'denyCallback' => function ($rule, $action) {
                    throw new \Exception('You are not allowed to access this page');
                }
            ],
        ];
    }


    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Displays Login page.
     *
     * @return string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->render('login_success', [
                'model' => $model,
            ]);
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Displays Login Success page
     *
     * @return string
     */
    public
    function actionLogin_success()
    {
        if (!Yii::$app->user->isGuest) {
            $model = new LoginForm();
            return $this->render('login_success', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Displays Welcome user
     *
     * @return string
     */
    public
    function actionWelcome()
    {
        return $this->render('welcome');
    }

    /**
     * Displays new user form
     *
     * @return string
     */

    public
    function actionCreate_user()
    {
        if (Yii::$app->user->isGuest) {
            $model = new NewUser();
            return $this->render('create_user', ['model' => $model]);
        }
    }

    public function actionRegister()
    {
        $model = new NewUser();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                $model->username = $_POST['NewUser']['username'];
                $model->email = $_POST['NewUser']['email'];
                $model->password = password_hash($_POST['NewUser']['password'], PASSWORD_ARGON2I);
                $model->authKey = md5(random_bytes((5)));
                $model->accessToken = password_hash(random_bytes(10), PASSWORD_DEFAULT);
                if ($model->save()) {
                    Yii::$app->mailer->compose()
                        ->setFrom('iardena.hernandez@wolfpackit.nl')
                        ->setTo($_POST['NewUser']['email'])
                        ->setSubject('Welcome to Wolfpack!')
                        ->setTextBody('Plain text content')
                        ->setHtmlBody('<b>Welcome, ' . ucwords($_POST['NewUser']['username']) . '!</b>')
                        ->send();
                    return $this->redirect(['site/login']);
                }
                return;
            }
        }

        return $this->render('register', [
            'model' => $model,
        ]);
    }
}

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

use yii\web\View;

/**
 * @var View $this
 */

echo \Yii::t('app', 'Welcome at the Wolfpack PHP Course');

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap\ActiveForm */

/* @var $model app\models\LoginForm */

/* @var $model app\models\LosginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>

<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 control-label'],
        ],
    ]); ?>

    <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

    <?= $form->field($model, 'password')->passwordInput() ?>

    <div class="form-group">
        <div class="col-lg-offset-1 col-lg-11">
            <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            <?= Html::a('Register', ['/site/register'], ['class' => 'btn btn-primary']) ?>
        </div>
    </div>

    <?php ActiveForm::end(); ?>
</div>

views/site/login_success.php
<?php

/* @var $this yii\web\View */

/* @var $model app\models\LoginForm */

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

$this->title = 'Login Success';
$this->params['breadcrumbs'][] = $this->title;

?>

<div class="site-login-success">
    <h1><?= Html::encode($this->title) ?></h1>
    <p>Welcome, <?= \Yii::$app->user->identity->username ?>!</p>
</div>

views/site/register.php
<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\NewUser */

/* @var $form ActiveForm */

$this->title = 'Register';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-register">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 control-label'],
        ],
    ]); ?>

    <?= $form->field($model, 'username')->textInput() ?>
    <?= $form->field($model, 'email')->textInput() ?>
    <?= $form->field($model, 'password')->passwordInput() ?>

    <div class="form-group">
        <div class="col-lg-offset-1 col-lg-11">
            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
        </div>
    </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-register -->

views/site/welcome.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'Welcome';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-welcome">
    <h1><?= Html::encode($this->title) ?></h1>
    <p>
        Welcome to Wolfpack!
    </p>
</div>